﻿package flash
{
	import flash.utils.Dictionary;
	import flash.net.FileReferenceList;
	import flash.display.Loader;
	import flash.events.Event;
	import flash.net.URLRequest;
	import flash.utils.clearInterval;

	public dynamic class Main extends flash.display.MovieClip
	{
		public var modSettingsLoader:Class;
		public var modDataLoader:Class;
		public var cData;
		private var main;
		private var key:Number = -1;
		private var modInd:Number = -1;
		private var modSets:Array = new Array();
		private var modLoading:Boolean = false;
		var cInd:int = 0;

		public function initl(l)
		{
			main = l;
			var msl = new modSettingsLoader("switchKey",settingsLoaded);
			msl.addEventListener("settingsNotFound",settingsNotFound);
		}
		function settingsNotFound(e)
		{
			main.updateStatus(e.msg);
			main.unloadMod();
		}
		function settingsLoaded(e)
		{
			var dict:Dictionary = e.settings;
			if (dict["key"] != null)
			{
				key = dict["key"];
				main.registerFunction(toggleModKey, key);
			}
			if (dict["sets"] != null)
			{
				var sets:Number = dict["sets"];
				for (var i:int = 0; i<sets; i++)
				{
					if (dict["set" + (i + 1)] != null)
					{
						modSets.push(dict["set" + (i+1)]);
					}
				}
			}
			toggleModKey();
			main.unloadMod();
		}
		function loadNextSet()
		{
			modInd = (modInd + 1 < modSets.length)?modInd + 1:0;			
			cInd = 0;
			loadData();
		}
		function loadData()
		{
			main.cData = cData;
			var modSet:Array = modSets[modInd].toString().split(",");
			if (cInd < modSet.length)
			{
				var mdl = new modDataLoader(modSet[cInd],cData,dataLoaded);
				mdl.addEventListener("dataNotFound",dataNotFound);
				}else{
					main.dialogueLoader.load(folderPath("Dialogue.txt"));
					main.ldr.load(folderPath("Code.txt"));
					main.obgLdr.load(folderPath("BG.png"));
					main.loadCharString("$OVER$");
					modLoading = false;
				}
				cInd++;
			}
			function folderPath(fName:String):URLRequest{
				return new URLRequest("Mods/" + cData + "/" + fName);
			}
			function toggleModKey()
			{
				if(!modLoading){
					modLoading = true;
					main.resetChar(false);
					loadNextSet();
					main.registerFunction(toggleModKey, key);
				}
			}

			function dataNotFound(e)
			{
				main.updateStatus(e.msg);
				main.unloadMod();
			}

			function dataLoaded(e)
			{
				var ldr:Loader = new Loader();
				ldr.contentLoaderInfo.addEventListener(Event.INIT, function mDLC(e){
					main.fileRef = true;
					clearInterval(main.loadInt);
					main.modDataLoadingComplete(e); 
					if(modLoading)
					{
						loadData();
					}
				});
				ldr.loadBytes(e.binData);
			}
		}
	}