//UI Controls PoC ~ ModGuy

import flash.display.MovieClip;
import flash.geom.Point;

package flash
{	
	public dynamic class Main extends MovieClip
	
	{

		//These don't need to be here.
		//Just seems useful in case I decide to add something later.
		public var Button:Class;
		public var Checkbox:Class;
		public var ItemSpinner:Class;
		public var Label:Class
		public var ListBox:Class;
		public var RadioButton:Class
		public var ScrollBox:Class;
		public var Slider:Class;
		public var Spinner:Class;
		public var TextInput:Class;

		public var loader;

		//These are here because I need to ref them later.
		//I could use an inline function to avoid this however.
		private var radioButton;
		private var radioButton2;
		private var radioButton3;
		private var sa;
		private var _l;

		public function initl(l){

			var s = new Slider(80,12);
			s.setMin(-1);
			s.setValue(0); //Always a good idea to refresh slider.

			_l = new Label(100,30,"Hello!");
			_l.y = 100;

			var cb = new Checkbox(16,16);
			cb.x = 140; cb.y = 20;
			cb.setChecked(true); //Wouldn't make sense for first check to do nothing.

			var lb = new ListBox(100,80);
			lb.x = 160; lb.y = 20;
			lb.addItem("Hello1", 0);
			lb.addItem("Hello2", 1);
			lb.addItem("Hello3", 4);
			lb.addItem("Hello4", 7);
			lb.addItem("Hello5", 12);
			lb.removeItem(7);	//7 should resolve to "Hello4"
			lb.removeItemAt(2);	//Should remove "Hello3"
			lb.addItem("HelloWorld!", ["any", "object", "is", "fine"]);

			//Declared globally.
			radioButton = new RadioButton(16, 16);
			radioButton2 = new RadioButton(16, 16);
			radioButton3 = new RadioButton(16, 16);
			radioButton.x = 140; radioButton.y = 44;
			radioButton2.x = 140; radioButton2.y = 64;
			radioButton3.x = 140; radioButton3.y = 84;

			sa = new ScrollBox(100,80);
			sa.x = 20; sa.y = 20;

			sa.addObject(s, new Point(10,0));
			sa.addObject(new Button(80,40, "Testing..."), new Point(10,20));
			sa.addObject(new Button(80,20, "lol"), new Point(10,70));

			radioButton.data = 1;
			radioButton2.data = 2;
			radioButton3.data = 3;
			radioButton.linkTo(radioButton2);
			radioButton.linkTo(radioButton3);
			radioButton.setChecked(true);

			radioButton.setOutlineOpacity(0);
			radioButton2.setBackHoverCol(0xFF0000);
			radioButton2.setTicksMax(100);
			radioButton3.setTicksMax(1);
			radioButton3.setOutlineCol(0x004400);
			radioButton3.setBackIdleCol(0x00AA00);
			radioButton3.setBackHoverCol(0x006600);
			radioButton3.setForeIdleCol(0x66FF66);
			radioButton3.setOutlineThickness(3);




			cb.addEventListener("checkboxClicked",checkboxClicked);
			radioButton.addEventListener("radioButtonClicked",radioClicked);
			radioButton2.addEventListener("radioButtonClicked",radioClicked);
			radioButton3.addEventListener("radioButtonClicked",radioClicked);
			lb.addEventListener("listboxChanged", lbc);

			var sp = new Spinner(110, 24);
			sp.x = lb.x + lb.width + 5;
			sp.y = lb.y;
			addChild(sp);
			sp.addEventListener("spinnerChanged", spi);
			sp.addEventListener("spinnerHeld", spiHeld);
			sp.heldThreshold = 6;
			
			var isp = new ItemSpinner(110, 24);
			isp.x = sp.x;
			isp.y = sp.y+sp.height+10;
			isp.addItem("Hello", 1);
			isp.addItem("World", 7);
			isp.addItem("Controls", 3);
			isp.addItem("Are", 6);
			isp.addItem("Neat", 9);
			isp.addEventListener("spinnerChanged", spi);
			
			
			
			var dsp = new Spinner(110, 24);
			dsp.x = isp.x;
			dsp.y = isp.y+isp.height+10;
			dsp.stringFormatter = function fmtString(e:Number):String {
					return e.toFixed(3);
			}
			dsp.addEventListener("spinnerHeld", spiHeld);
			dsp.addEventListener("spinnerChanged", spi);
			dsp.lowerBound = 5;
			dsp.upperBound = 40;
			dsp.tickValue = 125/1000;

			var ti = new TextInput(100, 30, "12345");
			ti.enforceMatch("[0-9]{1,5}", "");
			ti.x = 160;
			ti.y = 110;

			//Container acts as our modPage.
			var container = new MovieClip();
			//container.l = null;
			container.addChild(lb);
			container.addChild(_l);
			container.addChild(radioButton);
			container.addChild(radioButton2);
			container.addChild(radioButton3);
			container.addChild(cb);
			container.addChild(sa);
			container.addChild(sp);
			container.addChild(dsp);
			container.addChild(isp);
			container.addChild(ti);

			l.addPage(container, false);


			l.unloadMod();
		}
		function radioClicked(e){
			_l.tf.text = e.radioButton.data;
		}
		function lbc(e){
			_l.tf.text = e.listButton.textLabel.tf.text;
		}
		function checkboxClicked(e){
			_l.tf.text = "Chk: " + (e.checked ? 1 : 0);
			radioButton._enabled = e.checked;
			radioButton2._enabled = e.checked;
			radioButton3._enabled = e.checked;
			sa._enabled = e.checked;
		}

		function changed(e)
		{
			_l.tf.text = "Change:" + e.value;
		}
		function clicked(e)
		{
			_l.tf.text = "Click: " + e.slider.value;
		}
		function released(e)
		{
			_l.tf.text = "Release: " + e.value;
		}

		private function spi(ev):void
		{
			if(typeof(ev.object) == "number")
				_l.tf.text = ev.object.toString();
			else
				_l.tf.text = ev.object.label;
		}
		
		private function spiHeld(e):void
		{
			var tickRate:int = 8;
			if (e.time == 0) return;
			if (e.time > 20) tickRate = 4;
			if (e.time > 40) tickRate = 2;
			if (e.time > 60) tickRate = 1;
			if (e.time % tickRate != 0) return;
			if (e.direction == "<")	e.spinner.prev();
			else e.spinner.next();		
		}
	}

}